<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Login extends CI_Controller {
    function __construct(){
        parent::__construct();
        $this->load->database();
        $this->load->model('users_model');
    }
    function index(){
        if($this->session->userdata('is_loggedin')){
            redirect(base_url().'home');
        }else{
            $this->load->view('login');
        }
    }
    function login_user(){
        $username = $this->input->post('username');
        $password = sha1($this->input->post('password'));
        $check_user = $this->users_model->validate_user($username,$password);
        if($check_user == TRUE){
            $data = array(
                'is_loggedin'     => TRUE,
                'id'            => $check_user->id,
                'perfil'        => $check_user->perfil,
                'username'      => $check_user->username
            );
            $this->session->set_userdata($data);
            redirect(base_url().'home');
        }else{
            $this->session->set_flashdata('usuario_incorrecto','Los datos introducidos son incorrectos');
            redirect(base_url().'login','refresh');
        }
    }
    function logout(){
        //$this->session->unset_userdata('is_loggedin');
        $this->session->sess_destroy();
        $this->index();
    }
    function add_user(){
        $userdata = array(
            'perfil'    => 'Administrador',
            'username'  => 'admin',
            'password'  => sha1('admin')
        );
        $this->users_model->insert_user($userdata);
    }
}