<!DOCTYPE html>
<!--[if lt IE 7]> <html class="lt-ie9 lt-ie8 lt-ie7" lang="en"> <![endif]-->
<!--[if IE 7]> <html class="lt-ie9 lt-ie8" lang="en"> <![endif]-->
<!--[if IE 8]> <html class="lt-ie9" lang="en"> <![endif]-->
<!--[if gt IE 8]><!--> <html lang="en"> <!--<![endif]-->
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <title>Face Access - Login</title>
    <link rel="stylesheet" href="<?= asset_url('css/login.css')?>" type="text/css" media="screen" title="no title" charset="utf-8">
    <!--[if lt IE 9]><script src="//html5shim.googlecode.com/svn/trunk/html5.js"></script><![endif]-->
</head>
<body>
<section class="container">
    <div class="login">
        <h1>Face Access - Login</h1>
        <?php
        $username = array('name' => 'username', 'placeholder' => 'Nombre de usuario');
        $password = array('name' => 'password', 'placeholder' => 'Contraseña');
        $submit   = array('name' => 'submit', 'value' => 'Iniciar sesión', 'title' => 'Iniciar sesión');
        ?>
        <?=form_open(base_url().'login/login_user')?>
            <p><?=form_input($username)?><?=form_error('username')?></p>
            <p><?=form_password($password)?><?=form_error('password')?></p>
            <p class="remember_me">
                <label>
                    <input type="checkbox" name="remember_me" id="remember_me">
                    Recordarme
                </label>
            </p>
            <p class="submit"><?=form_submit($submit)?></p>
        <?=form_close()?>
        <?php if($this->session->flashdata('usuario_incorrecto')){?>
                <p><?=$this->session->flashdata('usuario_incorrecto')?></p>
        <?php }?>
    </div>
</section>
</body>
</html>