var cellA, cellMain, cellSubMain,
    cntFoto,
    dgvConsultarMes,
    dpf, dpg,
    frmEmpleado, frmMesConsultar,
    gridConsultarMes, gridPersonal,
    layoutMain,
    toolbarMain,
    winsMesConsultar;
var base_url,
    dont_print = false,
    gridConsultarMesRowIndex = 0,
    have_in = false,
    in_day = "*",
    in_hour = "*",
    out_day = "*",
    out_hour = "*",
    mesConsultar,
    message="",
    rowCellId_Personal,
    weekday = new Array(7),
    logObj;

var csrf_token_name, csrf_hash;

weekday[0] = "Domingo";
weekday[1] = "Lunes";
weekday[2] = "Martes";
weekday[3] = "Miércoles";
weekday[4] = "Jueves";
weekday[5] = "Viernes";
weekday[6] = "Sábado";

frmEmpleadoStr = [
    {type:"hidden", name:csrf_token_name, value:csrf_hash},
    {type:"settings", position:"label-left", labelWidth:"100", inputWidth:"225", noteWidth:"150", offsetLeft:"0",
        offsetTop:"0"},
    {type:"fieldset", name:"fldEmpleado", width:"580", label:"Empleado", offsetLeft:"10", list:[
        {type:"block", name:"blkFoto", width:"530", offsetLeft:"0", blockOffset:"0", list:[
            {type:"fieldset", name:"fsFoto", width:"520", offsetLeft:"0", offsetTop:"0", label:"Foto / Subir foto",
                list:[
                    {type:"container", name:"cntFoto", inputWidth:"80", offsetLeft:"0", offsetTop:"0"},
                    {type:"newcolumn", offset:"10"},
                    {type:"block", name:"upload", width:"330", offsetTop:"15", blockOffset:"60", list:[
                        {type:"upload", name:"uploadFoto", inputWidth:"330", url:"home/uploadAction",
                            autoStart:"false"}
                    ]}
            ]}
        ]},
        {type:"block", name:"blkDatos", width:"530", offsetLeft:"0", offsetTop:"0", blockOffset:"0", list:[
            {type:"input", name:"id_personal", label:"Legajo", position:"label-top", labelWidth:"50",
                inputWidth:"50", validate:"NotEmpty,ValidInteger"},
                {type:"newcolumn", offset:"10"},
                {type:"input", name:"apellido", label:"Apellido", position:"label-top", validate:"NotEmpty"},
                {type:"newcolumn", offset:"10"},
                {type:"input", name:"nombre", label:"Nombre", position:"label-top", validate:"NotEmpty"}
        ]},
        {type:"block", name:"blkDatos_", width:"530", offsetLeft:"0", offsetTop:"0", blockOffset:"60", list:[
            {type:"input", name:"direccion", label:"Direccion", position:"label-top"},
            {type:"newcolumn", offset:"10"},
            {type:"input", name:"email", label:"Email", position:"label-top", validate:"ValidEmail",
                note:{text:"ejemplo@dominio.com"}}
        ]},
        {type:"block", name:"blkDatos__", width:"530", offsetLeft:"0", offsetTop:"0", blockOffset:"60", list:[
            {type:"input", name:"telefono", label:"Teléfono", position:"label-top"},
            {type:"newcolumn", offset:"10"},
            {type:"input", name:"celular", label:"Celular", position:"label-top"}
        ]},
        {type:"block", name:"blkDatos___", width:"530", offsetLeft:"0", offsetTop:"0", blockOffset:"60",
            position:"label-top", list:[
                {type:"input", name:"hora_ingreso", label:"Hora de ingreso", numberFormat:"00:00:00",
                    position:"label-top",labelWidth:"225" , inputWidth:"60", validate:"ValidTime",
                    note:{text:"00:00:00"}},
                {type:"newcolumn", offset:"10"},
                {type:"block", name:"blkDatos____", width:"200", offsetLeft:"0", offsetTop:"0", blockOffset:"0",
                    position:"label-top", list:[
                        {type:"input", name:"horas_x_dia", label:"Horas por día", labelWidth:"75", position:"label-top",
                            inputWidth:"50", validate:"ValidInteger"},
                        {type:"newcolumn", offset:"50"},
                        {type:"checkbox", name:"is_active", checked:"false", label:"Activo", labelWidth:"75",
                            inputWidth:"75", position:"label-top"}
                    ]}
        ]},
        {type:"block", name:"blkObservaciones", width:"530", offsetLeft:"0", blockOffset:"0", list:[
            {type:"input", name:"observaciones", label:"Observaciones", position:"label-top",
                inputWidth:"520", rows : "4"}
        ]},
        {type:"block", name:"blkButtons", width:"180", offsetLeft:"342", blockOffset:"0", list:[
            {type:"button", name:"btnCancel", value:"Cancelar"},
            {type:"newcolumn"},
            {type:"button", name:"btnSave", value:"Guardar"}
        ]}
    ]}
];
frmMesConsultarStr = [
    {type:"settings", position:"label-top"},
    {type:"block", name:"blkCalendar", offsetTop:"10", offsetLeft:"40", list:[
        {type: "calendar", name:"mes", inputWidth:"100", dateFormat: "%Y-%m", calendarPosition: "right"}
    ]},
    {type:"block", name:"blkButtons", list:[
        {type:"button", name:"btnCancel", value:"Cancelar"},
        {type:"newcolumn"},
        {type:"button", name:"btnOk", value:"Aceptar"}
    ]}
];
dhtmlxEvent(window,"load", buildInterface);

function buildInterface(){
    dhtmlx.image_path=base_url+"/";
    //layoutMain = new dhtmlXLayoutObject(document.body, "3L");
    layoutMain = new dhtmlXLayoutObject(document.body, "2E");

    //cellA = layoutMain.cells("a");
    //cellA.attachHTMLString('<div id="log">Log (<a href="javascript:void(0);" onClick="clearLog();">Clear</a>)</div><div id="message"></div>');
    //cellA.setWidth(200);

    cellMain = layoutMain.cells("a");
    //cellMain = layoutMain.cells("b");
    cellMain.setText("Bienvenido");

    cellSubMain = layoutMain.cells("b");
    //cellSubMain = layoutMain.cells("c");
    cellSubMain.setText("");
    cellSubMain.collapse();

    toolbarMain = layoutMain.attachToolbar();
    toolbarMain.setIconsPath("assets/icons/");
    toolbarMain.loadStruct("assets/data/toolbarMain.xml");
    toolbarMain.attachEvent("onclick",function(id){
        if(id == "addEmpleado"){
            cellSubMain.collapse();
            cellMain.setText("Agregar");
            showView("frmEmpleado",cellMain);
            if((typeof gridPersonal != "undefined")){
                gridPersonal.clearSelection();
            }
            cntFoto.innerHTML = "";
            frmEmpleado.clear();
            frmEmpleado.setFocusOnFirstActive();
        }
        if(id == "modEmpleado"){
            if((typeof gridPersonal != "undefined")){
                cellSubMain.collapse();
                var selectedId = gridPersonal.getSelectedId();
                if(selectedId != null){
                    cellMain.setText("Editar");
                    showView("frmEmpleado",cellMain);
                    frmEmpleado.load("./home/frmEmpleadoData?id="+selectedId);
                    frmEmpleado.attachEvent("onBeforeDataLoad", function(id, values){
                        cntFoto.innerHTML = "<div class='image'><div class='trick'></div><img src='data:image/jpeg;base64,"+values["image"]+"' /></div>";
                        //console.log(id,values["image"]);
                        return true;
                    });
                    frmEmpleado.setFocusOnFirstActive();
                }else{
                    cellMain.setText("Buscar");
                    showView("search",cellMain);
                    cellSubMain.collapse();
                    clear_grid_filters(gridPersonal);
                    gridPersonal.clearAndLoad("./home/gridPersonalData");
                }
            }else{
                cellMain.setText("Buscar");
                showView("search",cellMain);
                cellSubMain.collapse();
                clear_grid_filters(gridPersonal);
                gridPersonal.clearAndLoad("./home/gridPersonalData");
            }
        }
        if(id == "delEmpleado"){
            if((typeof gridPersonal != 'undefined')){
                var rowId = gridPersonal.getSelectedId();//gridPersonal.getSelectedRowId();
                if(rowId != null){
                    var rowIndex = gridPersonal.getRowIndex(rowId);
                    var rowCellApellido = gridPersonal.cellByIndex(rowIndex,1).getValue();
                    var rowCellNombre = gridPersonal.cellByIndex(rowIndex,2).getValue();
                    dhtmlx.confirm({
                        title: "¡Atención!",
                        ok: "Si", cancel: "No",
                        type: "confirm-warning",
                        text: "¿Eliminar empleado "+rowCellApellido+", "+rowCellNombre+"?",
                        callback: function(result){
                            if(result){
                                gridPersonal.deleteRow(rowId);
                                if(rowIndex!=(gridPersonal.getRowsNum()-1)){
                                    gridPersonal.selectRow(rowIndex+1,true);
                                }else{
                                    gridPersonal.selectRow(rowIndex-1,true)
                                }
                            }
                        }
                    });
                }else{
                    cellMain.setText("Buscar");
                    showView("search",cellMain);
                    cellSubMain.collapse();
                    clear_grid_filters(gridPersonal);
                    gridPersonal.clearAndLoad("./home/gridPersonalData");
                }
            }else{
                cellMain.setText("Buscar");
                showView("search",cellMain);
                cellSubMain.collapse();
                clear_grid_filters(gridPersonal);
                gridPersonal.clearAndLoad("./home/gridPersonalData");
            }
        }
        if(id == "search"){
            cellMain.setText("Buscar");
            showView("search",cellMain);
            cellSubMain.collapse();
            clear_grid_filters(gridPersonal);
            gridPersonal.clearAndLoad("./home/gridPersonalData");
        }
        if(id == "exit"){
            location.href="/login/logout";
        }
    });
    cellMain.setText("Buscar");     //Iniciar en buscar
    showView("search",cellMain);
    cellSubMain.collapse();
    clear_grid_filters(gridPersonal);
    gridPersonal.clearAndLoad("./home/gridPersonalData");
}
function showView(name,cell){
    var state = cell.showView(name);
    if(state == true){
        if(name == "search"){
            gridPersonal = cell.attachGrid();
            gridPersonal.setHeader("Legajo,Apellido,Nombre");
            gridPersonal.attachHeader("#text_filter,#text_filter,#text_filter");
            gridPersonal.setInitWidths("100,*,*");
            gridPersonal.setColTypes("ro,ro,ro");
            gridPersonal.setColSorting("int,str_custom,str_custom");
            //gridPersonal.setCustomSorting(str_custom,1);
            //gridPersonal.enableMultiline(true);
            gridPersonal.attachEvent("onRowDblClicked",doOnRowDblClicked);
            gridPersonal.init();
            //gridPersonal.loadXML("./home/gridPersonalData");

            dpg = new dataProcessor("./home/gridPersonalData");
            dpg.action_param = "dhx_editor_status";
            dpg.init(gridPersonal);
        }
        if(name == "frmEmpleado"){
            frmEmpleado = cell.attachForm(frmEmpleadoStr);
            frmEmpleado.setFocusOnFirstActive();
                /*var inp1 = frmEmpleado.doWithItem("id_personal", "getInput");
                     inp1.tabIndex = 1;*/
            cntFoto = frmEmpleado.getContainer("cntFoto");
            //cntFoto.innerHTML = "<div class='image'><div class='trick'></div><img src='assets/uploaded/yo.jpg'></div>";
            /*frmEmpleado.forEachItem(function(name){
                var item = frmEmpleado.getItem(name);
                var type = frmEmpleado.getItemType(name);
                console.log(item, type)
            });*/
            frmEmpleado.attachEvent("onButtonClick", function(name){
                //logEvent("onButtonClick event called, item name '"+name+"'<br>");
                if(name == "btnSave"){
                    if(frmEmpleado.validate()){
                        if(frmEmpleado.getUploaderStatus("uploadFoto") != "1"){
                            dhtmlx.confirm({
                                title: "¡Atención!",
                                ok: "Si", cancel: "No",
                                type: "confirm-warning",
                                text: "¿Guardar empleado sin foto?",
                                callback: function(result){
                                    if(result){
                                        frmEmpleado.save();
                                    }
                                }
                            });
                        }else{
                            frmEmpleado.save();
                        }
                    }
                }
                if(name == "btnCancel"){
                    var formulario = frmEmpleado.getUploaderStatus("uploadFoto");
                    //msg("error",formulario);
                    frmEmpleado.clear();
                    cellMain.setText("Buscar");
                    showView("search",cellMain);
                    cellSubMain.collapse();
                    clear_grid_filters(gridPersonal);
                }
            });
            frmEmpleado.attachEvent("onUploadFail",function(message){
                //message=node.firstChild;
                // alert(message);
                msg("error",message);
                //logEvent("<b>onUploadFail</b>, file: "+realName);
            });
            frmEmpleado.attachEvent("onUploadComplete",function(count){
                frmEmpleado.attachEvent("onBeforeFileAdd",function(realName, size){
                    return false; //Un solo archivo
                });
                msg("error",count);
                //logEvent("<b>onUploadFail</b>, file: "+realName);
            });

            dpf = new dataProcessor("./home/frmEmpleadoData");
            //dpf.enableDebug;
            dpf.action_param = "dhx_editor_status";
            dpf.init(frmEmpleado);

            /*dpf.defineAction("my_error",my_action);
            function my_action(node){
                message=node.firstChild.data;
                    //alert(message);
                        m sg("error",message);
                            return false;
                                }*/

            dpf.attachEvent("onAfterUpdate", function(sid, action, tid, tag){
                var message = tag.getAttribute("details");
                if (message){
                    dhtmlx.alert({
                        title: "Info",
                        ok: "Aceptar",
                        text :message,
                        callback: function(){
                            frmEmpleado.clear(); //Sin esto no vuelve a guardar
                            frmEmpleado.setFocusOnFirstActive();
                        }
                    });
                }else{
                    dhtmlx.alert({
                        title: "Info",
                        ok: "Aceptar",
                        text: "¡Empleado cargardo!",
                        callback: function(){
                            frmEmpleado.clear();
                            frmEmpleado.setFocusOnFirstActive();
                        }
                    });
                }//dhtmlx.message(message);
            });
        }
        if(name == "listEmpleado"){
            dgvConsultarMes = cellSubMain.attachDataView({
                type:{
                    template:"#foto#<br/>#datetime#",
                    width:90,
                    height:120,
                    margin:0,
                    padding:0
                }
            });
            dgvConsultarMes.attachEvent("onItemClick", function (id, ev, html){
                //alert(id+","+ev+","+html);
                for (var j=0; j < gridConsultarMes.getRowsNum(); j++){
                    for (var i=1; i < 3; i++){
                        var cell = gridConsultarMes.cellByIndex(j,i).getValue();// j - the index of a row in the grid
                        //alert(id+'"'+cell+'"');
                        if (cell == id){
                            //alert(id+'"'+cell+'"'+"Paso");
                            gridConsultarMes.selectRow(j);
                        }
                    }
                }
                return true;
            });
            gridConsultarMes = cell.attachGrid();
            gridConsultarMes.setHeader("Día,Entrada,Salida");
            //gridConsultarMes.attachHeader("#text_filter,#text_filter,#text_filter");
            gridConsultarMes.setInitWidths("100,*,*");
            gridConsultarMes.setColTypes("ro,ro,ro");
            //gridConsultarMes.setColSorting("int,str_custom,str_custom");
            //gridConsultarMes.attachEvent("onRowDblClicked",doOnRowDblClicked);
            gridConsultarMes.attachEvent("onRowSelect", function(id,ind){
                var cell = gridConsultarMes.cellById(id,ind).getValue();
                if (cell > "0"){
                    dgvConsultarMes.select(cell);
                }
            });
            gridConsultarMes.init();

            gridConsultarMes._process_custom_xml=function(xml){
                this._parsing=true;
                var rows = xml.doXPath("//row");       //gets all row elements from XML
                for (var i = 0; i < rows.length; i++){
                    var id = this.getUID();      //XML has no native ids,so custom ids are generated
                    this.rowsBuffer[i]={                //stores references to each row element
                        idd: id,
                        data: rows[i],
                        _parser: this._process_custom_xml_row /*, //cell parser method
                        _locator: this._get_custom_xml_data    //data locator method*/
                    };

                    this.rowsAr[id]=rows[i];             //stores id reference
                }
                this.render_dataset();            //forces update of grid's view after data loading
                this._parsing=false;

                gridConsultarMesRowIndex = 0;
                in_day = in_hour = out_day = out_hour = "*";

                for (var j=0; j < gridConsultarMes.getRowsNum(); j++){
                    var cell = gridConsultarMes.cellByIndex(j,0).getValue(j);// j - the index of a row in the grid
                    if (cell == ""){
                        //alert('"'+cell+'"');
                        var rowId = gridConsultarMes.getRowId(j);
                        gridConsultarMes.deleteRow(rowId);
                    }
                }
            }
            gridConsultarMes._process_custom_xml_row=function(r, xml){
                var cell = this.xmlLoader.doXPath("./cell", xml); //gets cell sub-tag
                var week_day = (Date.createFromMysql(cell[1].firstChild.data)).getDay();
                var datetime = (cell[1].firstChild.data).split(" ");
                var is_in = cell[3].firstChild.data;
                var is_out = cell[4].firstChild.data;

                if (is_in == 1){
                    in_day = datetime[0];
                    in_hour = datetime[1];
                    have_in = true;
                    //alert("Entrada: "+is_in+","+in_day+","+in_hour+","+have_in);
                }else if (is_out == 1){
                    out_day = datetime[0];
                    //alert("Salida: "+have_in+","+in_day+","+out_day);
                    if (have_in == true && in_day == out_day){
                        out_hour = datetime[1];
                        gridConsultarMes.cellByIndex(gridConsultarMesRowIndex - 1,2).setValue(out_day+" "+out_hour);
                        have_in = false;
                        dont_print = true;
                        out_day = "*";
                        out_hour = "*";
                    }else{
                        in_day = "*";
                        in_hour = "*";
                        out_day = datetime[0];
                        out_hour = datetime[1];
                    }
                }
                if (is_in == 1 && have_in == true){
                    out_day = "*";
                    out_hour = "*";
                }
                var strAr = [
                    weekday[week_day],
                    in_day+" "+in_hour,
                    out_day+" "+out_hour
                ];
                //sets just a plain array as no custom attributes are needed
                r._attrs={};
                for (var j = 0; j < r.childNodes.length; j++) r.childNodes[j]._attrs={};

                //finishes data loading
                if (dont_print != true){
                    this._fillRow(r, strAr);
                }
                dont_print = false;
                gridConsultarMesRowIndex++;
                dgvConsultarMes.add({
                    id:cell[1].firstChild.data,
                    foto:"<div class='dgv-image'><div class='dgv-trick'></div><img src='data:image/jpeg;base64,"+cell[2].firstChild.data+"' /></div>",
                    datetime:"<div class='dgv-text'>"+cell[1].firstChild.data+"</div>"
                });
                return r;
            }
            /*gridConsultarMes._get_custom_xml_data=function(r, xml){
                alert('pepe');
            }*/
        }
        function logEvent(t,name,command) {
            if (!logObj) logObj = document.getElementById("simpleLog");
            logObj.innerHTML += t;
                //alert(logObj);
        }
    }
}
function doOnRowDblClicked(rowId){
    winsMesConsultar = new dhtmlXWindows();
    var w1 = winsMesConsultar.createWindow("w1", 0, 0, 235, 130);

    winsMesConsultar.window("w1").setModal(true);
    winsMesConsultar.window("w1").centerOnScreen();
    winsMesConsultar.window("w1").denyMove();
    winsMesConsultar.window("w1").denyResize();

    w1.setText("Mes a consultar");
    w1.button("park").hide();
    w1.button("minmax").hide();

    frmMesConsultar = w1.attachForm(frmMesConsultarStr);
    frmMesConsultar.getInput("mes").style.backgroundImage = "url(../assets/icons/calendar.gif)";
    frmMesConsultar.getInput("mes").style.backgroundPosition = "center right";
    frmMesConsultar.getInput("mes").style.backgroundRepeat = "no-repeat";

    frmMesConsultar.attachEvent("onButtonClick", function(name){
        if(name == "btnOk"){
            var rowId = gridPersonal.getSelectedId();
            var rowIndex = gridPersonal.getRowIndex(rowId);
                rowCellId_Personal = gridPersonal.cellByIndex(rowIndex,0).getValue();
            var rowCellApellido = gridPersonal.cellByIndex(rowIndex,1).getValue();
            var rowCellNombre = gridPersonal.cellByIndex(rowIndex,2).getValue();

            if(frmMesConsultar.getInput("mes").value != ""){
                mesConsultar = frmMesConsultar.getInput("mes").value;
                cellMain.setText(rowCellId_Personal+" - "+rowCellApellido+", "+rowCellNombre);
                if (winsMesConsultar != null && winsMesConsultar.unload != null){
                    winsMesConsultar.unload();
                    winsMesConsultar = w1 = null;
                }
                showView("listEmpleado",cellMain);
                cellSubMain.expand();
                gridConsultarMes.clearAndLoad("./home/gridConsultarMes?dhx_filter[id_personal]="+rowCellId_Personal+"&dhx_filter[app_datetime]="+mesConsultar, "custom_xml");
                dgvConsultarMes.clearAll();
            }else{
                dhtmlx.alert({
                    title: "Info",
                    ok: "Aceptar",
                    text: "Seleccione mes"
                });
            }
        }
        if(name == "btnCancel"){
            if (winsMesConsultar != null && winsMesConsultar.unload != null){
                winsMesConsultar.unload();
                winsMesConsultar = w1 = null;
            }
        }
    });
}
function str_custom(a,b,order,aid,bid){
    if (a==b){
        var a2=gridPersonal.cells(aid,1).getValue();
        var b2=gridPersonal.cells(bid,1).getValue();
        if(order=="asc") { return a2.toLowerCase()>b2.toLowerCase()?1:-1; }
        else { return a2.toLowerCase()<b2.toLowerCase()?1:-1; }
    }
    if(order=="asc") { return a.toLowerCase()>b.toLowerCase()?1:-1; }
    else { return a.toLowerCase()<b.toLowerCase()?1:-1; }
}
function clear_grid_filters(grid){
    for (var i=0; i < grid.getColumnCount(); i++) {
        var filter = grid.getFilterElement(i);
        if (filter) filter.value = '';
    }
    grid.filterByAll();
}
Date.createFromMysql = function(mysql_string){
    if(typeof mysql_string === 'string'){
        var t = mysql_string.split(/[- :]/);
        //when t[3], t[4] and t[5] are missing they defaults to zero
        return new Date(t[0], t[1] - 1, t[2], t[3] || 0, t[4] || 0, t[5] || 0);
    }
    return null;
};
/*dhtmlXForm.prototype.items.input.getInput= function(item){
    return item.childNodes[1].childNodes[0];
    }*/
(function(){
    for (var a in dhtmlXForm.prototype.items) {
        dhtmlXForm.prototype.items[a].getItem = function(item){
            return item;
        }
    }
})();
dhtmlXForm.prototype.getItem = function(name){
    return this.doWithItem(name, "getItem");
};
//================== Message ==================
function msg(status,message){
    var date = new Date();
    var hour = date.getHours();
    var minut = date.getMinutes();
    var sec = date.getSeconds();
    var jam = hour+":"+minut+":"+sec;
    var msg = document.getElementById("message");
    if (status=="error"){
        msg.innerHTML = "<li style='height:auto;'>"+jam+"<font color='#FF0000'> " + message + "</font></li>" + msg.innerHTML
    }else if (status=="info"){
        msg.innerHTML = "<li style='height:auto;'>"+jam+"<font color='#008000'> " + message + "</font></li>" + msg.innerHTML
    }else{
        msg.innerHTML = "<li style='height:auto;'>"+jam+" "+message+"</li>" + msg.innerHTML
    }
}
//================== Delete Message / Log ==================
function clearLog(){
    logObj = document.getElementById("message");
    logObj.innerHTML = "";
}